// main.h

// This example was made for MK64FN1M0XXX12 on Hexiwear.
//
// This is a blank project which includes all the files
// required for building an application that uses FreeRTOS,
// and can be used as a template for making your own FreeRTOS applications.
//
// It also includes the OLED library for Hexiwear.

// Includes

#include "main.h"
#include "OLED_driver.h"

// Public Function Definitions

// Task 1 - An example task.
void task1(void *pvParameters)
{
    // Initialize OLED.
    OLED_Init(void);
    OLED_FillScreen(OLED_COLOR_BLUE);
    OLED_WriteText("Welcome", 26, 44);
    
    while (1)
    {
        vTaskDelay(pdMS_TO_TICKS(1000));
    }
}

// Main function, which creates the tasks and starts the scheduler.
void main()
{
    // Create task 1.
    xTaskCreate(
        (TaskFunction_t)task1,
        "Task 1",
        configMINIMAL_STACK_SIZE,
        NULL,
        10,
        NULL
    );

    // Start the RTOS scheduler.
    vTaskStartScheduler();
    
    // Will never reach here.
    while (1);
}