// main.c

// This example was made for STM32F107VC on EasyMx PRO v7 for STM32.
//
// It uses buttons and an analog input for inputting user data,
// and shows the data on TFT display and LEDs.
//
// TFT will constantly be displaying the ADC input,
// as well as indicate which button was pressed.
// PORTD LEDs will be displaying the value of the ADC input as well,
// and will be blinking with a frequency
// that can be adjusted by pressing the appropriate buttons.
//
// The on-board potentiometer can be used to change the value of the ADC input.
// Buttons PB0, PB1, PB8, and PB9 can be used to change the blinking frequency
// of the LEDs that display the ADC input.
//
// The board should  be configured as follows:
// - Connect jumper J9 to PA3 (ADC channel 3 input).
// - Enable button press level SW10 for PORTB/H and PORTB/L.
// - Pull down on PORTB pins 0, 1, 8, and 9.
// - Turn on LEDs on PORTD/H and PORTD/L at SW15.
// - Turn ON TFT control switches at SW11.

// Includes

#include "main.h"

// Public Function Definitions

// Main function, which creates the tasks and starts the scheduler.
void main()
{
    // Create init task.
    xTaskCreate(
        (TaskFunction_t)initTask,
        "Init Task",
        configMINIMAL_STACK_SIZE,
        NULL,
        10,
        NULL
    );

    // Start the RTOS scheduler.
    vTaskStartScheduler();

    // Will never reach here.
    while (1);
}